#ifndef PRODUCTSVIEW_H
#define PRODUCTSVIEW_H

#include <Window.h>
#include <TextView.h>
#include <TextControl.h>
#include <Button.h>
#include <MessageFilter.h>
#include "stock.h"
#include "../layout/blayout.h"

#include "../libs/column/ColumnListView.h"
#include "../libs/column/ColumnTypes.h"

const uint EDIT_PRODUCT = '&edp';
const uint ADD_PRODUCT = '&adp';
const uint SAVE_PRODUCT = '&spr';
const uint UNVALID_PRODUCT = '&unv';
const uint PRODUCT_INVOKED = '&piv';
const uint ADD_TRADE = '&adt';
const uint NUMBER_MODIFIED = '&nmf';


class ProductRow : public BRow
{
	public:
		product_f *product;
};


class ProductView : public BView
{
	public:
						ProductView(BRect bounds);
		virtual void 	FrameResized(float width, float height);
		virtual void 	MakeFocus(bool focused);
		
				void 	AddProduct(product_f *product);
		//virtual void 	AttachedToWindow(void);
		//virtual void 	DetachedFromWindow(void);
				
				void 	BarcodeEntered(BString barcode);
				void	EditProduct(product_f *product = NULL);
				void	UpdateProduct(product_f *product);
				
		BColumnListView *fProductListView;
	
	private:
		BColumn *fNameColumn;
		BColumn *fPrizeColumn;
		BColumn *fSuppliesColumn;
		//BScrollView *fScrollView;	
		BList fUnvalidList;
};


class EditProductWindow  : public BWindow 
{
	public:
						EditProductWindow(BRect, const char*,product_f *product, bool sell = false, int32 tradeTime = 0);	
		virtual			~EditProductWindow(){
							delete fInvalidRequestInvoker;
						}
		virtual	void	MessageReceived(BMessage *msg);
		
				status_t GetProductInfo(product_f *productinfo);
				void	ParseNumberTextControl(BTextControl *textControl);
	private:
		int32 fInitialSupplies;
		bool fSell;
		int32 fTradeTime;
		
		Layout *fProductLayout;
		Layout *fHLayout;
		
		BTextControl *fNameEdit;
		BTextControl *fBarcodeEdit;
		BTextControl *fPrizeEdit;
		BTextControl *fCommentEdit;
		
		BTextControl *fAddSuppliesEdit;
		BTextControl *fSuppliesEdit;
		
		BButton *fOkButton;
		
		BInvoker* fInvalidRequestInvoker;
};


#endif